---------------------------------------------------------------------------
-- by ProtectionTM (̵ŨGUYTM) ե ͥ (http://www.inguild.com)
---------------------------------------------------------------------------

require "./AI/USER_AI/Const.lua"
require "./AI/USER_AI/Util.lua"
require "./AI/USER_AI/MovingCommand.lua"
require "./AI/USER_AI/Friend.lua"

IN_MOVE_LEFT = 1
IN_MOVE_RIGHT = 2
IN_MOVE_UP = 3
IN_MOVE_DOWN = 4
IN_MOVE_LEFTUP = 5
IN_MOVE_RIGHTUP = 6
IN_MOVE_LEFTDOWN = 7
IN_MOVE_RIGHTDOWN = 8

-----------------------------------------------------
-- ۥ󥯥륹å (蹶蹶)
IN_ATTACK_FORCE_NOT				= 0		-- 蹶
IN_ATTACK_FORCE_FORCE_MONSTER	= 1		-- 蹶
IN_ATTACK_FORCE_ALL				= 2		-- 桼ޤ蹶 (ڤ)


--  ID
IN_SKILL_MOONLIGHT			= 8009
IN_SKILL_FLEETMOVE			= 8010
IN_SKILL_OVERDSPEED			= 8011
IN_SKILL_CASTLING			= 8005
IN_SKILL_DEFENCE			= 8006
IN_SKILL_HEAL				= 8001
IN_SKILL_EMERGENCYAVOID		= 8002
IN_SKILL_CAPRICE			= 8013
IN_SKILL_VENEDICTION		= 8014
-----------------------------------------------------

-- Υ󥹥ƨ˴
IN_flee_enemyid = 0

-----------------------------------------------------
-- Vector utility
-- by ̵ŨGUYTM ե ͥ (http://www.inguild.com)
-----------------------------------------------------
Vector = {}

function Vector.new (xvalue, yvalue)
	local vx = 0
	local vy = 0

	if (xvalue ~= nil and yvalue == nil) then
		vx = xvalue.x
		vy = xvalue.y
	elseif (xvalue ~= nil and yvalue ~= nil) then
		vx = xvalue
		vy = yvalue
	end

	return { x = vx, y = vy }
end

function Vector.set(vector, x, y)
	vector.x = x
	vector.y = y
end

-- : ʬȤ normalize 
function Vector.normalize(vector)
	local v = math.sqrt(vector.x*vector.x + vector.y*vector.y); 
	if (v == 0) then
		vector.x = 1
		vector.y = 0
	else
		vector.x = vector.x / v
		vector.y = vector.y / v
	end
	return vector
end

function Vector.minus(vector1, vector2)
	return Vector.new(vector1.x - vector2.x, vector1.y - vector2.y)
end

function Vector.plus(vector1, vector2)
	return Vector.new(vector1.x + vector2.x, vector1.y + vector2.y)
end

function Vector.multiple(vector1, vector2)
	return Vector.new(vector1.x * vector2.x, vector1.y * vector2.y)
end

function Vector.divide(vector1, vector2)
	if(vector2.x == 0 or vector2.y == 0) then
		return nil
	end
	return Vector.new(vector1.x / vector2.x, vector1.y / vector2.y)
end

function Vector.multiple_dis(vector, dis)
	return Vector.new(vector.x * dis, vector.y * dis)
end

-- : ʬȤ floor 
function Vector.floor(vector, d)
	local f = 0.0
	if(d ~= nil) then
		f = d;
	end
	vector.x = math.floor(vector.x + f)
	vector.y = math.floor(vector.y + f)
	return vector
end
-----------------------------------------------------





-- ۥबƨΰ֤ (٤ƤΤȽǤ뤳ȤǤʤ)
function GetFleePosition(myx, myy, enemyx, enemyy, dis)
	local vmy = Vector.new(myx, myy)
	local venemy = Vector.new(enemyx, enemyx)
	local v = Vector.minus(vmy, venemy)

	v = Vector.floor( Vector.multiple_dis(Vector.normalize(v), dis), 0.5 )
	v.x = v.x + myx;
	v.y = v.y + myy;
	return v
end


-- ۥबƨΰ֤ (٤ƤΤȽǤ뤳ȤǤʤ)
function GetFleePosition2(myid, enemyid)
	local x1, y1 = GetV (V_POSITION,myid)
	local x2, y2 = GetV (V_POSITION,enemyid)
	return Vector(x1,y1, x2,y2)
end


-- ۥबͤθƨΰ
function GetFleeToOwnerBehind(ownerid, enemyid)
	if(enemyid ~= 0) then
		IN_flee_enemyid = enemyid
	else
		enemyid = IN_flee_enemyid
	end

	if(enemyid == 0) then
		local x1, y1 = GetV (V_POSITION, ownerid)
		return Vector.new(x1,y1-1)
	end

	local x1, y1 = GetV (V_POSITION, ownerid)
	local x2, y2 = GetV (V_POSITION, enemyid)

	local vowner = Vector.new(x1, y1)
	local venemy = Vector.new(x2, y2)
	local v, vdis, vnormal

	vdis = Vector.minus(vowner, venemy)
	vnormal = vdis
	Vector.normalize(vnormal)
	v = Vector.plus( vdis, Vector.multiple(vnormal, Vector.new(3,3)) )
	return Vector.plus(vowner, Vector.floor(v, 0.5))
end

-- vpos1 ֤ vpos2  cell Υ줿֤
function GetPosition1toPosition2(vpos1, vpos2, cell)
	local vnormal = Vector.minus(vpos2, vpos1)
	Vector.normalize(vnormal)
	v = Vector.plus( vnormal, Vector.multiple(vnormal, Vector.new(cell,cell)) )
	v = Vector.plus( v, vpos1 )
	return v
end



-- function VectorTest()
-- 	local v;
-- 	v = GetFleeToOwnerBehind(0,0)
-- 	print("flee: %d %d\n", v.x, v.y)
-- end

-- VectorTest()


-- Ĥä HP Υѡ
function GetHPPercent(id)
	local mysp = GetV (V_HP,id)
	local mymaxsp = GetV (V_MAXHP,id)
	return (mysp / mymaxsp) * 100.0
end


-- Ĥä SP Υѡ
function GetSPPercent(id)
	local mysp = GetV (V_SP,id)
	local mymaxsp = GetV (V_MAXSP,id)
	return (mysp / mymaxsp) * 100.0
end


-- ŨID𤫤ɤ?
function IsPlants(enemyid)
	return false
end

-- ۥ󥯥륹ι⡼ɤ (蹶,蹶)
function GetHomunAttackMode(id)
	local type = GetV (V_HOMUNTYPE,id)

	if(type == AMISTR or type == AMISTR_H or type == AMISTR2 or type == AMISTR_H2 ) then
		return OPT["IN_AMISTR"]
	elseif(type == FILIR or type == FILIR_H or type == FILIR2 or type == FILIR_H2) then
		return OPT["IN_FILIR"]
	elseif(type == LIF or type == LIF_H or type == LIF2 or type == LIF_H2) then
		return OPT["IN_LIF"]
	elseif(type == VANILMIRTH or type == VANILMIRTH_H or type == VANILMIRTH2 or type == VANILMIRTH_H2) then
		return OPT["IN_VANILMIRTH"]
	end
	TraceAI(string.format("GetAttackMode : d% " , id))
	return 0
end

-- Υ桼(󥹥,,ʬǤϤʤ) 
-- CACHE_GetUsers = 0
-- IN_Users = { }
function GetUsers(myid)
	local actors = GetActors()
	local owner = GetV(V_OWNER, myid)
	local IN_Users = { }

--	if(CACHE_GetUsers == 1) then
--		return IN_Users
--	end

--	CACHE_GetUsers = 1
--	for i,v in ipairs(IN_Users) do
--		IN_Users[i] = nil
--	end

	local n = 1
	for i,v in ipairs(actors) do
		if (1 ~= IsMonster(v) and v ~= myid and v ~= owner) then
--		if (v ~= myid and v ~= owner) then
			IN_Users[n] = v
			n = n + 1
		end
	end
	return IN_Users
end

-- ܥƥå
function IsSteal(myid, enemyid)
	local target = GetV (V_TARGET,enemyid)
	
	if (target == 0 or target == myid or target == GetV(V_OWNER, myid) or IsFriend(target) == true) then
		return false
	end
	return true
end

-- ۥबƥ뤹󥹥ƥѤߤɤ?

function IsStealMyTarget(myid, myenemy)
	local users = GetUsers(myid)
	local motion
	local usersenemy

	local enemytarget = GetV(V_TARGET, myenemy)

	if(IsSteal(myid, myenemy) == true) then
		return false;
	end

	for i,v in ipairs(users) do
		usersenemy = GetV(V_TARGET, v)
		if(usersenemy == myenemy) then
			motion = GetV(V_MOTION, v)
			if(motion == MOTION_ATTACK or motion == MOTION_ATTACK2) then
				return true
			end
		end
	end
	return false
end

-- ۥȼͤεΥȤƤ󤤾ͤΰ֤˰ư
MoveToOwnerWhenTooFar_LastMyState = -1
function MoveToOwnerWhenTooFar(myid)
	local owner = GetV(V_OWNER, myid)
	local dis = GetDistance2(owner, myid)

	if(dis < 12) then		
		if(MoveToOwnerWhenTooFar_LastMyState ~= -1 and dis < 6) then
			MyState = MoveToOwnerWhenTooFar_LastMyState
			MoveToOwnerWhenTooFar_LastMyState = -1
			TraceAI("MoveToOwnerWhenTooFar()")
		end		
		return
	end

	MoveToOwner(myid)

--	if(MyState == CHASE_ST or MyState == ATTACK_ST or MyState == ATTACK_OBJECT_CMD_ST or ATTACK_AREA_CMD_ST) then
--		MoveToOwnerWhenTooFar_LastMyState = IDLE_ST
--	end

	if(MyState ~= FOLLOW_CMD_ST) then
		MoveToOwnerWhenTooFar_LastMyState = IDLE_ST
	end
	MyState = FOLLOW_CMD_ST
	
end


------------------------------------------------------------------
------------------------------------------------------------------
------------------------------------------------------------------

Time_Casting_DelayCount = 0

-- Ʈ漫ư⥹
function Cast_SkillWhenFight(myid)

	local type = GetV (V_HOMUNTYPE,myid)

	if(type == FILIR or type == FILIR_H or type == FILIR2 or type == FILIR_H2) then
		if(OPT["IN_AutoMonlight"] == 1 and GetSPPercent(myid) >= OPT["IN_AutoMonlight_SP"]) then
			SkillObject(myid, 5, IN_SKILL_MOONLIGHT, GetV(V_TARGET,myid))
			return 1
		end
	elseif(type == VANILMIRTH or type == VANILMIRTH_H or type == VANILMIRTH2 or type == VANILMIRTH_H2) then
		if(OPT["IN_AutoCaprice"] == 1 and GetSPPercent(myid) >= OPT["IN_AutoCaprice_SP"]) then
			SkillObject(myid, 5, IN_SKILL_CAPRICE, GetV(V_TARGET,myid))
			return 1
		end
	end

	--TraceAI (string.format(Cast_SkillWhenFight: %d, type: %d\n, myid, type)

	return 0
end

-- Ʈ˥ե뤬Ȥ
Time_Casting_FleetMove = 0
Time_Casting_OveredMove = 0
Time_Casting_Defence = 0

function Cast_SkillWhenStartFight(myid)
	if(GetTick() < Time_Casting_DelayCount) then
		return 
	end

	local type = GetV (V_HOMUNTYPE,myid)

	if(type == FILIR or type == FILIR_H or type == FILIR2 or type == FILIR_H2) then
		local sp = GetSPPercent(myid)
		local tick = GetTick()

		if(OPT["IN_AutoFleetMove"] == 1 and sp >= OPT["IN_AutoFleetMove_SP"] and tick > Time_Casting_FleetMove) then
			Time_Casting_FleetMove = tick + 40000
			Time_Casting_DelayCount = tick + 3000
			SkillObject(myid, 5, IN_SKILL_FLEETMOVE, myid)
			return 1
		elseif(OPT["IN_AutoOveredSpeed"] == 1 and sp >= OPT["IN_AutoOveredSpeed_SP"] and tick > Time_Casting_OveredMove) then
			Time_Casting_OveredMove = tick + 40000
			Time_Casting_DelayCount = tick + 3000
			SkillObject(myid, 5, IN_SKILL_OVERDSPEED, myid)
			return 1
		end
	elseif(type == AMISTR or type == AMISTR_H or type == AMISTR2 or type == AMISTR_H2 ) then
		local sp = GetSPPercent(myid)
		local tick = GetTick()

		if(OPT["IN_AutoDefence"] == 1 and sp >= OPT["IN_AutoDefence_SP"] and tick > Time_Casting_Defence) then
			Time_Casting_Defence = tick + 20000
			Time_Casting_DelayCount = tick + 3000
			SkillObject(myid, 5, IN_SKILL_DEFENCE, myid)
			return 1
		end
	end
	return 0
end

---------------------------------------------------------------------
-- ߥȥ뤬ʻå󥰻
Already_Castling = 0
function Cast_SkillCastling(myid)
	if(GetTick() < Time_Casting_DelayCount) then
		return 
	end

	local type = GetV (V_HOMUNTYPE,myid)

	if(type == AMISTR or type == AMISTR_H or type == AMISTR2 or type == AMISTR_H2) then
		local hp = GetHPPercent(myid)
		if(OPT["IN_AutoCastling"] == 1 and hp <= OPT["IN_AutoCastling_HP"] and Already_Castling == 0) then
			Already_Castling = 1
			SkillObject(myid, 5, IN_SKILL_CASTLING, myid)
			return 1
		elseif(Already_Castling == 1 and hp > OPT["IN_AutoCastling_HP"]) then
			Already_Castling = 0
		end
	end
	return 0
end

function Cast_SkillCastling_Owner(myid)
	if(GetTick() < Time_Casting_DelayCount) then
		return 
	end

	local type = GetV (V_HOMUNTYPE,myid)

	if(type == AMISTR or type == AMISTR_H or type == AMISTR2 or type == AMISTR_H2) then
		local hp = GetHPPercent(GetV(V_OWNER,myid))
		if(OPT["IN_AutoCastling_Owner"] == 1 and hp <= OPT["IN_AutoCastling_Owner_HP"] and Already_Castling == 0) then
			Already_Castling = 2
			SkillObject(myid, 5, IN_SKILL_CASTLING, myid)
			return 1
		elseif(Already_Castling == 2 and hp > OPT["IN_AutoCastling_Owner_HP"]) then
			Already_Castling = 0
		end
	end
	return 0
end

function CastlingAlready_Reset()
	Already_Castling = 0
end
---------------------------------------------------------------------

-- ꡼դΥҡ
function Cast_SkillHeal(myid)
	local type = GetV (V_HOMUNTYPE,myid)

	if(type == LIF or type == LIF_H or type == LIF2 or type == LIF_H2) then
		if(OPT["IN_AutoHeal"] == 1 and GetHPPercent(myid) <= OPT["IN_AutoHeal_HP"]) then
			SkillObject(myid, 5, IN_SKILL_HEAL, myid)
			return 1
		elseif(OPT["IN_AutoHeal_Owner"] == 1 and GetHPPercent(GetV(V_OWNER,myid)) <= OPT["IN_AutoHeal_Owner_HP"]) then
			SkillObject(myid, 5, IN_SKILL_HEAL, GetV(V_OWNER,myid))
			return 1
		end
	end
	return 0
end

-- ꡼դζ۵޲
Time_Casting_EmergencyAvoid = 0
Lif_Last_Move_Avoid_X = 0
Lif_Last_Move_Avoid_Y = 0
function Cast_EmergencyAvoid(myid)
	if(GetTick() < Time_Casting_DelayCount) then
		return 
	end

	local x, y = GetV(V_POSITION, GetV(V_OWNER,myid))
	if(x == Lif_Last_Move_Avoid_X and y == Lif_Last_Move_Avoid_Y) then
		return 
	end

	local type = GetV (V_HOMUNTYPE,myid)

	if(Lif_Last_Move_Avoid_X == 0 and Lif_Last_Move_Avoid_Y == 0) then
		Lif_Last_Move_Avoid_X = x;
		Lif_Last_Move_Avoid_Y = y;
		return 
	end

	Lif_Last_Move_Avoid_X = x;
	Lif_Last_Move_Avoid_Y = y;

	if(type == LIF or type == LIF_H or type == LIF2 or type == LIF_H2) then
		local tick = GetTick()
		if(OPT["IN_AutoEmergencyAvoid"] == 1 and tick >= Time_Casting_EmergencyAvoid) then
			Time_Casting_DelayCount = tick + 3000
			Time_Casting_EmergencyAvoid = tick + 5000
			SkillObject(myid, 5, IN_SKILL_EMERGENCYAVOID, myid)
			return 1
		end
	end
	return 0
end

-- ꡼դζ۵޲ (HP)
function Cast_EmergencyAvoid_HP(myid)
	if(GetTick() < Time_Casting_DelayCount) then
		return 
	end

	local type = GetV (V_HOMUNTYPE,myid)

	if(type == LIF or type == LIF_H or type == LIF2 or type == LIF_H2) then
		local tick = GetTick()
		if(OPT["IN_AutoEmergencyAvoidHP"] == 1 and GetHPPercent(myid) <= OPT["IN_AutoEmergencyAvoid_HP"]) then
			Time_Casting_DelayCount = tick + 3000
			Time_Casting_EmergencyAvoid = tick + 5000
			SkillObject(myid, 5, IN_SKILL_EMERGENCYAVOID, myid)
			return 1
		elseif(OPT["IN_AutoEmergencyAvoidHP"] == 1 and GetHPPercent(GetV(V_OWNER,myid)) <= OPT["IN_AutoEmergencyAvoid_Owner_HP"]) then
			Time_Casting_DelayCount = tick + 3000
			Time_Casting_EmergencyAvoid = tick + 5000
			SkillObject(myid, 5, IN_SKILL_EMERGENCYAVOID, myid)
			return 1
		end
	end
	return 0
end

-- Х˥ߥȤΥƥå٥ͥǥ
function Cast_SkillVenediction(myid)
	local type = GetV (V_HOMUNTYPE,myid)

	if(type == VANILMIRTH or type == VANILMIRTH_H or type == VANILMIRTH2 or type == VANILMIRTH_H2) then
		if(OPT["IN_ChaoticVenediction"] == 1 and GetHPPercent(myid) <= OPT["IN_ChaoticVenediction_HP"]) then
			SkillObject(myid, 5, IN_SKILL_VENEDICTION, myid)
			return 1
		elseif(OPT["IN_ChaoticVenediction"] == 1 and GetHPPercent(GetV(V_OWNER,myid)) <= OPT["IN_ChaoticVenediction_Owner_HP"]) then
			SkillObject(myid, 5, IN_SKILL_VENEDICTION, myid)
			return 1
		end
	end
	return 0
end


-- ưƨ˴
FLAG_Stop_Fight = 0
function AutoFlee(myid, myenemy)

	if( myenemy ~= 0 ) then
		-- Ʈƨ
		if( GetHPPercent(myid) <= OPT["IN_MyAutoFleeHP"] ) then
			FLAG_Stop_Fight = 1
			--IN_enemyid = myenemy
			local v = GetFleeToOwnerBehind(GetV(V_OWNER,myid), myenemy)
			OnMOVE_AND_HOLD_CMD(v.x, v.y)
		end
	else
		if(IN_flee_enemyid ~= 0) then
			-- äƨ, Ԥʤá
			if( GetHPPercent(myid) <= OPT["IN_MyAutoFleeHP"] ) then
				FLAG_Stop_Fight = 1
				--IN_enemyid = myenemy
				local v = GetFleeToOwnerBehind(GetV(V_OWNER,myid), myenemy)
				OnMOVE_AND_HOLD_CMD(v.x, v.y)
			else
				OnATTACK_OBJECT_CMD(IN_flee_enemyid)
				IN_flee_enemyid = 0
			end
		end
	end

end


-- Ʈ (Ũõ)?
function isStopSearchEnemy()
	return FLAG_Stop_Fight
end

function ResetStopSearchEnemy()
	FLAG_Stop_Fight = 0
end



-- FLAG_AI_CONFIGURE_RUNNED = 0
function ExecAIConfigure()
--	if(FLAG_AI_CONFIGURE_RUNNED == 1) then
--		return 
--	end

--	FLAG_AI_CONFIGURE_RUNNED = 1
	os.execute("AI\\USER_AI\\AiConfigureRunner.exe")
end


---------------------------------------------------------------
-- AI ϻټ¹ ()
---------------------------------------------------------------
FLAG_IN_InitAI = 0
function IN_InitAI()

	-- ٤¹
	if(FLAG_IN_InitAI == 0) then
		TraceAI("IN_InitAI()")
		FLAG_IN_InitAI = 1;
		LoadSetting()
		LoadFriend()

--		if(0 ~= GetHomunAttackMode(MyID)) then
--			if(GetV(V_POSITION, MyID) == GetV(V_POSITION, GetV(V_OWNER, MyID)) ) then
--				MyState = FOLLOW_CMD_ST
--			end
--		end
	end

	-- 桼ã
--	CACHE_GetUsers = 0

end

-----------------------------------------------------------------------
